<script setup lang="ts">
import { computed, ref, watch } from 'vue'

import ProductList from '../components/ProductList.vue'
import ReceiptItemList from '../components/ReceiptItemList.vue'
import MemberSearch from '../components/MemberSearch.vue'

import { useAuthStore } from '@/views/Authentication/stores/auth'

import { type ReceiptItem } from '../types/ReceiptItem'
import { type Product } from '@/views/Product/types/Product'
import type { Receipt } from '../types/Receipt'
import ReceiptPaper from './ReceiptPaper.vue'
import { onMounted } from 'vue'
import type { Member } from '../types/Member'
import { useReceiptStore } from '../stores/receipt'
import { usePosStore } from '../stores/pos'

const receiptStore = useReceiptStore()
const authStore = useAuthStore()
const posStore = usePosStore()
const snackbar = ref(false)
const showMemberBox = ref(false)
const log = ref('')
const product = ref<Product>()
const receiptItemList = ref<typeof ReceiptItemList | null>(null)
const dialogReceipt = ref(false)
function selected(p: Product) {
  if (!p.id) return
  product.value = p
  const newReceiptItem: ReceiptItem = {
    id: -1,
    name: p.name,
    price: p.price,
    unit: 1,
    productId: p.id
  }
  receiptStore.addReceiptItem(newReceiptItem)
  snackbar.value = true
}

<<<<<<< HEAD
const dialogReceipt = ref(false)
=======
const currentUser = authStore.getCurrentUser()

const clearForm = () => {}

// const refreshReceiptItems = () => {
//   receiptStore.receiptItems.value = [...receiptItems.value]
// }

const tab = ref(null)
onMounted(async () => {
  await posStore.getProducts()
})

function selectedMember(member: Member) {}
>>>>>>> a34926f024a5890ea9d5d42410292a2e15854c19
</script>

<template>
  <v-container class="fill-height" fluid>
    <v-row>
      <!-- Left Column -->
      <v-col cols="12" md="6" class="fill-height d-flex">
        <v-sheet
          width="100%"
          elevation="0"
          rounded
          style="background-color: rgba(205, 129, 61, 0.66)"
        >
          <v-container>
            <v-row>
              <v-col>
                <h1
                  style="
                    font-family: cursive;
                    font-weight: bold;
                    color: rgb(1, 1, 1);
                    font-size: 35px;
                  "
                >
                  Point of Sale
                </h1>
              </v-col>
              <v-col></v-col>
            </v-row>
          </v-container>
          <v-tabs color="brown" align-tabs="start" class="ma-5">
            <v-tab :value="1"><v-icon icon="mdi-coffee"></v-icon>Drink</v-tab>
            <v-tab :value="2"><v-icon icon="mdi-cake-variant"></v-icon>Bakery</v-tab>
            <v-tab :value="3"><v-icon icon="mdi-silverware-fork-knife"></v-icon>Food</v-tab>
            <!-- <v-text-field v-model="productName" density="compact" variant="solo" label="Product Search"
                            class="pa-2" append-inner-icon="mdi-magnify" single-line hide-details
                            @click:append-inner="onClick" @keyup.enter="onClick"></v-text-field> -->
          </v-tabs>

          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList :products="posStore.products1" @selected="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList :products="posStore.products2" @selected="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList :products="posStore.products3" @selected="selected"></ProductList>
            </v-window-item>
          </v-window>

          <!-- search bar -->
          <!-- <v-container>
            <v-row>
              <v-spacer />
              <v-col cols="6">
                <v-text-field v-model="productName" density="compact" variant="solo" label="Product Search"
                  append-inner-icon="mdi-magnify" single-line hide-details @click:append-inner="onClick"
                  @keyup.enter="onClick"></v-text-field>
              </v-col>
            </v-row>
          </v-container> -->
        </v-sheet>
      </v-col>

      <!-- Right Column -->
      <v-col cols="12" md="6" class="fill-height d-flex">
        <v-sheet width="auto" elevation="0" rounded style="background-color: rgba(0, 0, 0, 0)">
          <v-row no-gutters>
            <!-- Nested Containers -->

            <!-- Receipt Detail Table -->
            <v-col cols="12">
              <v-sheet elevation="0" rounded style="background-color: rgba(205, 129, 61, 0.66)">
                <h1
                  style="
                    font-family: cursive;
                    font-weight: bold;
                    color: black;
                    padding-left: 35px;
                    margin: 5px;
                    font-size: 38px;
                  "
                >
                  Order List
                </h1>
                <ReceiptItemList
                  v-model="receiptStore.receiptItems"
                  :editable="true"
                ></ReceiptItemList>

                <!-- <ReceiptDetailTable :tableHeight="420"></ReceiptDetailTable> -->
              </v-sheet>
            </v-col>

            <v-col cols="12">
              <v-sheet max-width="600" min-width="300" height="80" elevation="3">
                <MemberSearch @selected="selectedMember"></MemberSearch>
              </v-sheet>
            </v-col>
            <v-col cols="6">
              <v-sheet
                min-width="200"
                height="160"
                elevation="0"
                class="clearColor"
                style="background-color: rgba(205, 129, 61, 0.66); color: white"
              >
                <v-container style="text-align: center">
                  <v-row>
                    <v-col class="text-h5" cols="12"
                      >รวมเงิน : {{ receiptStore.receipt.total }} บาท</v-col
                    >
                    <v-col class="text-h5" cols="12"
                      >รวม : {{ receiptStore.receipt.amount }} ชิ้น</v-col
                    >
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>

            <v-col cols="6">
              <v-sheet
                min-width="200"
                height="160"
                elevation="0"
                class="clearColor"
                style="background-color: rgba(205, 129, 61, 0.66); color: white"
              >
                <PaymentCard />
              </v-sheet>
            </v-col>

            <!-- Buttons and Actions -->
            <v-sheet max-width="600" min-width="300" height="100" elevation="3">
              <v-container style="text-align: center">
                <v-row>
                  <v-col
                    ><v-btn
                      color="red"
                      @click="
                        () => {
                          clearForm()
                        }
                      "
                      >ยกเลิก</v-btn
                    ></v-col
                  >
                  <v-col>
                    <v-btn @click="dialogReceipt = true">ชำระเงิน</v-btn>
                  </v-col>
                </v-row>
              </v-container>
            </v-sheet>
          </v-row>
        </v-sheet>
      </v-col>

      <!-- Duplicate ReceiptDetailTable -->
      <!-- <v-sheet width="auto" height="250" elevation="6">
                                <ReceiptDetailTable></ReceiptDetailTable>
                            </v-sheet> -->

      <!-- MemberCard and PointCard -->

      <!-- <v-col cols="12">
              <h3 style="cursor: pointer;" class="pl-5" @click="showMemberBox = !showMemberBox">Member Action<v-icon
                  :icon="showMemberBox ? 'mdi-chevron-up' : 'mdi-chevron-down'"></v-icon></h3>
              <v-expand-transition>
                <div v-show="showMemberBox">
                  <v-row no-gutters>
                    <v-col cols="6">
                      <v-sheet width="auto" height="150" elevation="0"
                        style="background-color: #fef1dea4; color: black">
                        <MemberCard />
                      </v-sheet>
                    </v-col>
                    <v-col cols="6">
                      <v-sheet width="auto" height="150" elevation="0"
                        style="background-color:  #fef1dea4; color: black">
                        <PointCard></PointCard>
                      </v-sheet>
                    </v-col>
                  </v-row>

                </div>
              </v-expand-transition>

            </v-col> -->

      <!-- <v-divider vertical color="black"></v-divider> -->
      <!-- <v-col cols="6">
                            
                        </v-col> -->

      <!-- ReceiptCard and PaymentCard -->
      <!-- <v-col cols="6">
              <v-sheet min-width="200" height="160" elevation="0" class="clearColor"
                style="background-color: rgba(205, 129, 61, 0.66); color: white"> -->
      <!-- <ReceiptCard /> -->
      <!-- </v-sheet>
            </v-col>
            <v-divider vertical color="black"></v-divider>
            <v-col cols="6">
              <v-sheet min-width="200" height="160" elevation="0" class="clearColor"
                style="background-color: rgba(205, 129, 61, 0.66); color: white"> -->
      <!-- <PaymentCard /> -->
    </v-row>

<<<<<<< HEAD
          <!-- Buttons and Actions -->
          <v-container>
=======
    <!-- Buttons and Actions -->
    <!-- <v-container>
>>>>>>> a34926f024a5890ea9d5d42410292a2e15854c19
            <v-row>
              <v-col cols="6">
                <v-btn block rounded="l" color="#a16942" size="large" @click="showMemberDialog()">
                  <v-icon start icon="mdi-wallet-membership"></v-icon>Register Member
                </v-btn>
              </v-col>
              <v-col cols="6">
                <v-btn block rounded="l" color="red-lighten-1" size="large" @click="() => {
              receiptStore.clear()

            }">
                  <v-icon start icon="mdi-close"></v-icon>Cancel
                </v-btn>
              </v-col>
              <v-col cols="6">
                <v-btn block rounded="l" color="#693a18" size="large" @click="showPromotionDialog()">
                  <v-icon start icon="mdi-star"></v-icon>Promotion
                </v-btn>
              </v-col>


              <v-dialog max-width="340">
                <template #activator="{ props }">
                  <v-col cols="6">
                    <v-btn v-bind="props" rounded="l" color="green-darken-2" size="large" @click="dialogReceipt">
                      <v-icon start icon="mdi-currency-usd"></v-icon>Payment
                    </v-btn>
                  </v-col>
                </template>
                <template v-slot:default="{ isActive }">
                  <v-card prepend-icon="mdi-package"
                    text="Successfully"
                    title="Payment">
                    <template v-slot:actions>
                      <v-btn class="ml-auto" text="Close" @click="isActive.value = false"></v-btn>
                    </template>
                  </v-card>
                </template>
              </v-dialog>
            </v-row>
          </v-container>

    <!-- change layout v-->
  </v-container>
  <!-- <ReceiptPaper
    v-model:modelValue="dialogReceipt"
    :receipt="receiptStore.receipt"
    :receiptItems="receiptStore.receiptItems"
    @agree="
      () => {
        receiptStore.order()
      }
    "
  ></ReceiptPaper> -->
</template>
